Predicted GNSS navigation models

Request predicted GNSS navigation models for GPS, GLONASS, Galileo, or BeiDou satellite systems.

This service provides predicted navigation models for a certain amount of upcoming days in a
series of LPP messages, each of which covers a specific time interval, as shown in the table below:

GNSSMessage validityTotal prediction
GPS4 hoursup to 14 days
GLONASS30 minutesup to 14 days
Galileo4 hoursup to 7 days
BeiDou4 hoursup to 7 days

Note, these values are based on the current service configuration and may be changed
in future. The validity period of each LPP message is provided in the response, so clients
should rely on that information instead of the values in the table above.

The service returns prediction data for up to 48 hours per request.
Client specifies required GNSS system(s) and the start time for the prediction data
by query parameters 'gps', 'glo', 'gal' and 'bds' for GPS, GLONASS, Galileo and BeiDou
systems, respectively.

To get the first 48 hours of prediction data for a specific GNSS system,
the client can set the corresponding parameter to now, or to the current time as Unix time
or GNSS time in seconds. The first LPP message for the corresponding GNSS system
in the response will have a validity interval that covers this start time,
and the following LPP messages will have consecutive validity intervals that together
cover up to 48 hours of prediction data.

Each LPP message in the response contains predicted navigation models for just one GNSS system.
Each body part in multipart responses corresponds to a single LPP message for a specific
GNSS system and is described with following headers:

  • X-Constellation indicating the GNSS system of the message,
    with values gps, glo, gal or bds for GPS, GLONASS, Galileo and BeiDou systems,
    respectively
  • X-Validity-Start indicating the validity start time in seconds since Unix epoch
  • X-GNSS-Validity-Start indicating the validity start time in seconds since
    corresponding GNSS epoch
  • X-Validity-Duration indicating the validity duration in seconds

JSON responses contain the same validity information in the validity field with each LPP message.

To get prediction data for next 48-hour intervals, send follow-up requests.
In order to avoid receiving duplicate LPP messages, set each time parameter
to the validity end time of the last received LPP message for the corresponding GNSS system.
The validity end time can be calculated as the sum of the validity start time and
the validity duration. For simplicity of client implementation, the service sends
the query string with properly set time parameters for the next request for prediction data
in the X-Prediction-Next response header.

For example, suppose the initial client's request is GET /v2/prediction?gps=now&glo=now.
The response contains prediction data for GPS and GLONASS systems,
and the last LPP message for GPS has validity
start time 1772380800 and validity duration 14400, while the last LPP message
for GLONASS has validity start time 1772393400 and validity duration 1800.
The response also contains header X-Prediction-Next: gps=1772395200&glo=1772395200.
The client can calculate new time parameters for each constellation by adding the validity
start times and durations, or simply use the value of X-Prediction-Next header,
to build the next request URL: GET /v2/prediction?gps=1772395200&glo=1772395200.
(This example uses Unix times, but the same logic applies if the client uses GNSS times.
Both the initial and the next request URLs might need additional parameters,
such as lpp or apiKey.)

Repeating this process, the client can get prediction data for the full 14-day period
for GPS and GLONASS systems in 7 requests, and for the full 7-day period for
Galileo and BeiDou systems in 4 requests.

Query Params
≥ 0

Requests predicted navigation models for GPS system starting from the specified time, as Unix time or GPS time, in seconds. The validity interval of the first LPP message in the response covers this start time. Validity intervals of all LPP messages are consecutive and together they cover up to 48-hour time interval.

The service only provides data within the range from current time up to the total GPS prediction period in the future. If this parameter defines a time interval outside this range, then no GPS prediction messages are included in the response. Special value now is used to request predictions starting from the current time.

If this parameter is not provided, the response does not include GPS predictions.

≥ 0

Requests predicted navigation models for GLONASS system starting from the specified time, as Unix time or GLONASS time, in seconds. The validity interval of the first LPP message in the response covers this start time. Validity intervals of all LPP messages are consecutive and together they cover up to 48-hour time interval.

The service only provides data within the range from current time up to the total GLONASS prediction period in the future. If this parameter defines a time interval outside this range, then no GLONASS prediction messages are included in the response. Special value now is used to request predictions starting from the current time.

If this parameter is not provided, the response does not include GLONASS predictions.

≥ 0

Requests predicted navigation models for Galileo system starting from the specified time, as Unix time or Galileo time, in seconds. The validity interval of the first LPP message in the response covers this start time. Validity intervals of all LPP messages are consecutive and together they cover up to 48-hour time interval.

The service only provides data within the range from current time up to the total Galileo prediction period in the future. If this parameter defines a time interval outside this range, then no Galileo prediction messages are included in the response. Special value now is used to request predictions starting from the current time.

If this parameter is not provided, the response does not include Galileo predictions.

≥ 0

Requests predicted navigation models for BeiDou system starting from the specified time, as Unix time or BeiDou time, in seconds. The validity interval of the first LPP message in the response covers this start time. Validity intervals of all LPP messages are consecutive and together they cover up to 48-hour time interval.

The service only provides data within the range from current time up to the total BeiDou prediction period in the future. If this parameter defines a time interval outside this range, then no BeiDou prediction messages are included in the response. Special value now is used to request predictions starting from the current time.

If this parameter is not provided, the response does not include BeiDou predictions.

string
enum
Defaults to uper

Specifies the encoding format for the LPP messages in the response.
Supported values as per ASN.1 specification are:

  • jer: JSON Encoding Rules (JER).
    The response content type depends on Accept header and can be either of the following:
    • application/json-seq (default) - JSON text sequences with each item containing a single LPP message in JER format.
    • application/json - single JSON object, which contains one or more LPP messages in JER format.
    • application/x-ndjson - newline-delimited JSON objects, each containing a single LPP message in JER format.
  • uper: Unaligned Packed Encoding Rules (UPER).
    The response content type is multipart/mixed and it consists of
    one or more binary LPP messages in application/octet-stream format.

Prediction navigation models can be large, so UPER encoding is recommended for this endpoint
to reduce the response size. If client requests JER encoding for prediction data,
the server always compresses the response (by default with "gzip" content encoding).
If the client disables all supported compression methods via Accept-Encoding header,
the server will respond with status code 406 "Not Acceptable".

Allowed:
string
enum
Defaults to data

Specifies the LPP ASN.1 element to be used as the root element for the LPP messages in the response.
Supported values are:

  • data: The root element is the A-GNSS-ProvideAssistanceData sequence.
  • full: The root element is the LPP-Message sequence.

Clients might be able to reduce the size of the code used to parse ASN.1 messages
by requesting data as the root element, especially for binary encodings, such as UPER.

Allowed:
string
length between 4 and 101

A list of up to six billing tags, separated by the + sign. This parameter provides a way to track your platform usage. For details, refer to the Cost Management Developer Guide section on Billing Tags.

Headers
string

Indicates preferred content encodings in the response. The server uses content negotiation (see RFC 9110) to select the best option and informs the choice in the Content-Encoding response header. Supported encodings are: "gzip", "deflate", "br" (and "identity"). If this header is missing, the response may or may not be compressed, client has to check the response headers for that information. If all supported encodings are disabled (e.g. "*;q=0"), the server will respond with status code 406 "Not Acceptable".

string

User-provided token that can be used to trace a request or a group of requests sent to the service. Can be any string, but UUID is recommended. It will be echoed in the response.

string
enum
Defaults to application/json

Generated from available response content types

Allowed:
Responses

Language
Credentials
LoadingLoading…
Response
Click Try It! to start a request and see the response here! Or choose an example:
multipart/mixed
application/json
application/x-ndjson
application/json-seq